{   Denis Butorin. 31.12.03, E-Mail: subritto@ngs.ru;
Web: http://subritto.h1.ru}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, AgentObjects_TLB, StdCtrls, ActiveX, ComCtrls, speech, ComObj,
  ExtCtrls;

type
  TForm1 = class(TForm)
    Agent1: TAgent;
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    PosX: TEdit;
    PosY: TEdit;
    X: TLabel;
    Y: TLabel;
    Button2: TButton;
    ListBox1: TListBox;
    Label1: TLabel;
    ComboBox1: TComboBox;
    RichEdit1: TRichEdit;
    Button3: TButton;
    tagCHR: TButton;
    cbCHR: TComboBox;
    tagCTX: TButton;
    cbCTX: TComboBox;
    tagEmp: TButton;
    tagLST: TButton;
    tagMAP: TButton;
    edSpText: TEdit;
    Label2: TLabel;
    edBlText: TEdit;
    tagMRK: TButton;
    Bevel1: TBevel;
    edMrk: TEdit;
    tagPAU: TButton;
    edPau: TEdit;
    tagPIT: TButton;
    edPit: TEdit;
    tagSPD: TButton;
    edSpd: TEdit;
    tagVOL: TButton;
    edVol: TEdit;
    tagRST: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure tagCHRClick(Sender: TObject);
    procedure tagCTXClick(Sender: TObject);
    procedure tagEmpClick(Sender: TObject);
    procedure tagLSTClick(Sender: TObject);
    procedure tagRSTClick(Sender: TObject);
    procedure tagMRKClick(Sender: TObject);
    procedure tagPAUClick(Sender: TObject);
    procedure tagPITClick(Sender: TObject);
    procedure tagSPDClick(Sender: TObject);
    procedure tagVOLClick(Sender: TObject);
    procedure tagMAPClick(Sender: TObject);
    procedure Agent1Bookmark(Sender: TObject; BookmarkID: Integer);
  private
    { Private declarations }
    Req: IAgentCtlRequest;{    }
    Chars: IAgentCtlCharacterEx;{      }

    aTTSEnum: ITTSEnum;
      {   }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  s: String;//  
  i: integer;//  

procedure ShowAgentAnim;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  NumFound : DWord;
  ModeInfo : TTSModeInfo;
begin
 {      'merlin.acs'   'Merlin'.
          ,    }
 Agent1.Characters.Load('MyAgent', 'Genie.acs');
 {    Character}
 Chars:= Agent1.Characters.Character('MyAgent') as IAgentCtlCharacterEx;
 ShowAgentAnim; 
 {-  ,  ,      .
     ,    ,   
       }
 Req:=Chars.Show(0);

 {        
      ITTSEnum}
  CoCreateInstance(CLSID_TTSEnumerator, Nil, CLSCTX_ALL, IID_ITTSEnum, aTTSEnum);
  aTTSEnum.Reset;//  
  aTTSEnum.Next(1, ModeInfo, @NumFound); {  }
  While NumFound > 0 do
   begin
     ComboBox1.Items.Add(String(ModeInfo.szModeName));
     aTTSEnum.Next(1, ModeInfo, @NumFound); { }
   end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Agent1.Characters.Unload('MyAgent');
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 if OpenDialog1.Execute then //   
   begin
    if Chars<>nil then { -  ,  }
      Agent1.Characters.Unload('MyAgent');
    Agent1.Characters.Load('MyAgent', OpenDialog1.FileName);
    Chars:= Agent1.Characters.Character('MyAgent') as IAgentCtlCharacterEx;
    ShowAgentAnim;
    Req:=Chars.Show(0);
   end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Chars.Stop(Req);
  {  .
   ,   ,  }
  Req:=Chars.MoveTo(StrToInt(PosX.Text), StrToInt(PosY.Text), 1);
end;

procedure ShowAgentAnim;
var
  AEnum: IEnumVariant;
  flag: Cardinal;
  V: OleVariant;
begin
 with Form1 do
  begin
   AEnum:=(Chars.AnimationNames.Enum) as IEnumVariant;
   {   }
   AEnum.Reset; //    
   ListBox1.Items.Clear;
   repeat
     AEnum.Next(1, V, flag);
     if VarToStr(V) <> '' Then
       ListBox1.Items.Add(V);
   until flag=0; {   0,      }
  end;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  Chars.Stop(Req);
  Req:=Chars.Play(ListBox1.Items.Strings[ListBox1.ItemIndex])
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var
 NumFound: DWord;
 ModeInfo: TTSModeInfo;{     }
begin
   try
     CoCreateInstance(CLSID_TTSEnumerator, Nil, CLSCTX_ALL, IID_ITTSEnum, aTTSEnum);
     aTTSEnum.Reset;
     {   }
     Form1.aTTSEnum.skip(ComboBox1.ItemIndex);
     aTTSEnum.Next(1, ModeInfo, @NumFound);
     {    }
     Chars.Set_TTSModeID(GUIDToString(ModeInfo.gModeID));
   except
   end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 Req:=Chars.Speak(RichEdit1.Text, '')
end;

procedure TForm1.tagCHRClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 i:=RichEdit1.SelStart+1;
 insert('\Chr="'+cbCHR.Text+'"\', s, i);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.tagCTXClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 i:=RichEdit1.SelStart+1;
 insert('\Ctx="'+cbCTX.Text+'"\', s, i);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.tagEmpClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 i:=RichEdit1.SelStart+1;
 insert('\Emp\', s, i);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.tagLSTClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 i:=RichEdit1.SelStart+1;
 insert('\Lst\', s, i);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.tagRSTClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 i:=RichEdit1.SelStart;
 insert('\Rst\', s, i);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.tagMRKClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 i:=RichEdit1.SelStart+1;
 insert('\Mrk='+edMrk.Text+'\', s, i);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.tagPAUClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 i:=RichEdit1.SelStart+1;
 insert('\Pau='+edPau.Text+'\', s, i);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.tagPITClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 i:=RichEdit1.SelStart+1;
 insert('\Pit='+edPit.Text+'\', s, i);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.tagSPDClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 i:=RichEdit1.SelStart+1;
 insert('\Spd='+edSpd.Text+'\', s, i);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.tagVOLClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 i:=RichEdit1.SelStart+1;
 insert('\Vol='+edVol.Text+'\', s, i);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.tagMAPClick(Sender: TObject);
begin
 s:=RichEdit1.Lines.Text;
 i:=RichEdit1.SelStart+1;
 insert('\Map="'+edSpText.Text+'"="'+edBlText.Text+'"\', s, i);
 RichEdit1.Lines.Text:=s;
end;

procedure TForm1.Agent1Bookmark(Sender: TObject; BookmarkID: Integer);
begin
 ShowMessage('   '+IntToStr(BookmarkID));
end;

end.
